package de.fernunihagen.viptool.algorithm.folding.epcoflpo.datastructure.epc.buildingblocks;

import java.util.Vector;

import de.fernunihagen.viptool.algorithm.folding.epcoflpo.datastructure.lpo.Activity;

public class ActivitySet extends Vector<Activity> {

	private static final long serialVersionUID = 1L;

	@Override
	public boolean equals(Object other) {
		if (other != null && other instanceof ActivitySet) {
			Vector<Activity> activities = new Vector<Activity>();
			activities.addAll(this);

			ActivitySet otherSet = (ActivitySet) other;

			if (otherSet.size() != this.size()) {
				return false;
			}

			for (Activity activity : otherSet) {
				if (!activities.contains(activity)) {
					return false;
				}
				activities.remove(activity);
			}

			if (activities.isEmpty()) {
				return true;
			} else {
				return false;
			}
		}
		return false;
	}

	public boolean containsActivitySet(ActivitySet other) {
		for (Activity activity : other) {
			if (!contains(activity)) {
				return false;
			}
		}
		return true;
	}
}
