package de.fernunihagen.viptool.algorithm.folding.epcoflpo.datastructure.lpo.exec;

import java.util.HashMap;
import java.util.Vector;

import de.fernunihagen.viptool.algorithm.folding.epcoflpo.datastructure.epc.EPCFunction;
import de.fernunihagen.viptool.algorithm.folding.epcoflpo.datastructure.epc.exec.EpcState;
import de.fernunihagen.viptool.algorithm.folding.epcoflpo.datastructure.lpo.Activity;
import de.fernunihagen.viptool.algorithm.folding.epcoflpo.datastructure.lpo.Lpo;
import de.fernunihagen.viptool.algorithm.folding.epcoflpo.datastructure.lpo.Vertex;

public class WrongContinuation {

	private Vector<LpoState> lpos;

	private EpcState epc;

	private Lpo run;

	private EPCFunction wcFunction;

	private Vertex wcVertex;

	private HashMap<Lpo, HashMap<Vertex, Vector<Vertex>>> specificationPresets;

	private Vector<Activity> specificationPreLabels;

	public WrongContinuation(EpcState epc, EPCFunction wcFunction,
			Vertex wcVertex,
			HashMap<Lpo, HashMap<Vertex, Vector<Vertex>>> specificationPresets,
			Vector<Activity> specificationPreLabels) {
		this.lpos = epc.getEnabledLpos();
		this.epc = epc;
		this.wcFunction = wcFunction;
		this.wcVertex = wcVertex;

		this.specificationPreLabels = specificationPreLabels;
		this.specificationPresets = specificationPresets;

		run = epc.getRun();
		run.finishConstruction();
	}

	public HashMap<Lpo, HashMap<Vertex, Vector<Vertex>>> getSpecificationPresets() {
		return specificationPresets;
	}

	public Vector<LpoState> getLpos() {
		return lpos;
	}

	public Lpo getRun() {
		return run;
	}

	public EpcState getEpc() {
		return epc;
	}

	public Vector<Activity> getWrongContinuationPreset() {
		return wcVertex.getPreActivities();
	}

	public Vector<Activity> getSpecificationPreLabels() {
		return specificationPreLabels;
	}

	public String getLabel() {
		return wcFunction.getLabel();
	}

	@Override
	public String toString() {
		return "Wrong continuation " + wcFunction.getLabel() + " for lpos "
				+ lpos + ". Preset: " + getWrongContinuationPreset()
				+ ", Specification pre labels: " + getSpecificationPreLabels();
	}

}
