package de.fernunihagen.viptool.algorithm.folding.epcoflpo.datastructure.lpo.util;

import java.util.Vector;

import de.fernunihagen.viptool.algorithm.folding.epcoflpo.datastructure.lpo.Activity;
import de.fernunihagen.viptool.algorithm.folding.epcoflpo.datastructure.lpo.LpoEdge;

public class ActivityPair {

	private Activity start;

	private Activity end;

	private Vector<LpoEdge> pairEdges;

	private int distance;

	public ActivityPair(Activity start, Activity end, int distance) {
		this.start = start;
		this.end = end;

		this.distance = distance;

		pairEdges = new Vector<LpoEdge>();
	}

	public Vector<LpoEdge> getPairEdges() {
		return pairEdges;
	}

	public void addPairEdge(LpoEdge pairEdge) {
		pairEdges.add(pairEdge);
	}

	public void addAllPairEdges(Vector<LpoEdge> pairEdges) {
		this.pairEdges.addAll(pairEdges);
	}

	public Activity getStart() {
		return start;
	}

	public Activity getEnd() {
		return end;
	}

	public String toString() {
		return "(" + start + ", " + end + ")";
	}

	public int getDistance() {
		return distance;
	}

}
