package de.fernunihagen.viptool.algorithm.folding.epcoflpo.io.epml;

import java.util.Vector;

/**
 * This class orders a set of objects.
 * 
 * @author thomas
 */
public class IdAssigner {

	/**
	 * all ordered objects
	 */
	private Vector<Object> elements;

	/**
	 * Constructs a new IdAssigner
	 */
	public IdAssigner() {
		elements = new Vector<Object>();
	}

	/**
	 * Adds a new object to the order
	 * 
	 * @param o
	 *            object to order
	 */
	public void assign(Object o) {
		if (elements.contains(o)) {
			return;
		}

		elements.add(o);
	}

	/**
	 * Returns the id of the given object. If it was not ordered it is added
	 * automatically.
	 * 
	 * @param o
	 *            object to get the index for
	 * @return index of the object
	 */
	public int lookup(Object o) {
		if (!elements.contains(o)) {
			assign(o);
		}

		return elements.indexOf(o) + 1;
	}
}
