package de.fernunihagen.viptool.algorithm.folding.epcoflpo.plugin;

import viptool.base.IWorkbench;
import viptool.extension.Extension;
import de.fernunihagen.viptool.algorithm.folding.epcoflpo.plugin.resources.SynthesisResourceConstants;

public class EpcFoldingExtension extends Extension {
	// the instace of the extension
	private static EpcFoldingExtension instance_ = null;

	/**
	 * Constructs a new instance of the extension. If there is already an
	 * instance an IllegalStateException will be thrown. This constructor MUST
	 * NOT be called from the user. Only the ExtensionLoader of viptool may
	 * instantiate a new object of this extension.
	 */
	public EpcFoldingExtension() {
		if (instance_ != null) {
			throw new IllegalStateException(
					"The extension has already been created!");
		}

		instance_ = this;
	}

	// <><><><><><><><><><><><><><><><><><><><><>
	// Implementation of the singleton pattern
	// <><><><><><><><><><><><><><><><><><><><><>
	/**
	 * Returns the instance of the of the extension. Only one instance per
	 * viptool session is allowed. If the extension does not exist, an
	 * IllegalStateException is thrown.
	 * 
	 * @return the instance of this instance
	 */
	public static synchronized EpcFoldingExtension getInstance() {
		if (instance_ == null) {
			throw new IllegalStateException(
					"The extension has not been created yet!");
		}

		return instance_;
	}

	// <><><><><><><><><><><><><><><><><><><><><>
	// Overridden methods from viptool.extension.Extension
	// <><><><><><><><><><><><><><><><><><><><><>

	/* @see viptool.extenstion.Extension */
	public void initialize(IWorkbench workbench) {
		// we should call the super method to store the workbench reference
		super.initialize(workbench);

		// register the actions, menu, contextmenu, toolbar
		registerActions(SynthesisResourceConstants.XML_ACTIONS_SYNTHESIS_LPOSSS);
		registerContextMenu(SynthesisResourceConstants.XML_CONTEXTMENU_SYNTHESIS_LPOSSS);
	}

	/* @see viptool.extenstion.Extension */
	public void terminate() {
		instance_ = null;
	}

	/* @see viptool.extenstion.Extension */
	public String getName() {
		return "SynthesisOfLPO_SSS";
	}

	protected String getResourceBase() {
		return "resources";
	}

}
