package de.fernunihagen.viptool.algorithm.folding.epcoflpo.plugin;

import viptool.base.error.CannotOpenFileException;
import viptool.job.IProgressMonitor;
import viptool.job.Job;
import viptool.job.error.JobRuntimeException;
import viptool.logger.ILogger;
import viptool.project.FileSystem;
import viptool.project.IProject;
import de.fernunihagen.viptool.algorithm.folding.epcoflpo.run.FoldLposToEpc;

public class EpcFoldingJob extends Job {
	private String[] input_;
	private String output_;

	private IProject project_;

	public EpcFoldingJob(IProject project, String input[], String output) {
		super("EPC Folding", "fold lpo nets to a epc net", Job.MODE_BACKGROUND,
				Job.PRIORITY_NORMAL);

		input_ = input;
		output_ = output;
		project_ = project;
	}

	public void cancel() {
		// TODO Auto-generated method stub

	}

	public boolean needLoggerConsole() {
		return false;
	}

	public int run(ILogger logger, IProgressMonitor monitor)
			throws JobRuntimeException {
		FoldLposToEpc.foldLposToEpc(input_, output_);

		project_.updateFiles(true);

		try {
			EpcFoldingExtension
					.getInstance()
					.getWorkbench()
					.openFile(
							FileSystem.getInstance()
									.createAbstractFile(output_));
		} catch (CannotOpenFileException exception) {
			logger.error(exception.getMessage());
		}

		return 0;
	}

}
