package de.fernunihagen.viptool.algorithm.folding.epcoflpo.test;

import java.util.Vector;

import de.fernunihagen.viptool.algorithm.folding.epcoflpo.datastructure.lpo.Lpo;
import de.fernunihagen.viptool.algorithm.folding.epcoflpo.datastructure.lpo.Vertex;

public class TestLpoGenerator {

	public static Vector<Lpo> getCoffeeLpos() {
		Vector<Lpo> lpos = new Vector<Lpo>();

		lpos.add(getFirstExampleLpo());
		lpos.add(getSecondExampleLpo());

		return lpos;
	}

	public static Vector<Lpo> getDefaultExample() {
		Lpo lpo = new Lpo("xy");

		Vertex a = lpo.addVertex("a");
		Vertex x = lpo.addVertex("x");
		Vertex b = lpo.addVertex("b");
		Vertex y = lpo.addVertex("y");
		Vertex c = lpo.addVertex("c");

		lpo.connectVertices(a, x);
		lpo.connectVertices(x, b);
		lpo.connectVertices(b, y);
		lpo.connectVertices(y, c);

		lpo.finishConstruction();

		Lpo lpo2 = new Lpo("xy");

		Vertex a2 = lpo2.addVertex("a");
		Vertex u = lpo2.addVertex("u");
		Vertex b2 = lpo2.addVertex("b");
		Vertex v = lpo2.addVertex("v");
		Vertex c2 = lpo2.addVertex("c");

		lpo2.connectVertices(a2, u);
		lpo2.connectVertices(u, b2);
		lpo2.connectVertices(b2, v);
		lpo2.connectVertices(v, c2);

		lpo2.finishConstruction();

		Vector<Lpo> lpos = new Vector<Lpo>();

		lpos.add(lpo);
		lpos.add(lpo2);

		return lpos;
	}

	public static Vector<Lpo> getPaperDefaultExample() {
		Lpo lpo = new Lpo("xy");

		Vertex s = lpo.addVertex("s");
		Vertex a = lpo.addVertex("a");
		Vertex x = lpo.addVertex("x");
		Vertex b = lpo.addVertex("b");
		Vertex y = lpo.addVertex("y");
		Vertex c = lpo.addVertex("c");
		Vertex d = lpo.addVertex("d");
		Vertex e = lpo.addVertex("e");

		lpo.connectVertices(a, x);
		lpo.connectVertices(x, b);
		lpo.connectVertices(b, y);
		lpo.connectVertices(y, c);

		lpo.connectVertices(s, a);
		lpo.connectVertices(s, d);
		lpo.connectVertices(c, e);
		lpo.connectVertices(d, e);

		lpo.finishConstruction();

		Lpo lpo2 = new Lpo("uv");

		Vertex s2 = lpo2.addVertex("s");
		Vertex a2 = lpo2.addVertex("a");
		Vertex u = lpo2.addVertex("u");
		Vertex b2 = lpo2.addVertex("b");
		Vertex v = lpo2.addVertex("v");
		Vertex c2 = lpo2.addVertex("c");
		Vertex d2 = lpo2.addVertex("d");
		Vertex e2 = lpo2.addVertex("e");

		lpo2.connectVertices(a2, u);
		lpo2.connectVertices(u, b2);
		lpo2.connectVertices(b2, v);
		lpo2.connectVertices(v, c2);

		lpo2.connectVertices(s2, a2);
		lpo2.connectVertices(s2, d2);
		lpo2.connectVertices(c2, e2);
		lpo2.connectVertices(d2, e2);

		lpo2.finishConstruction();

		Vector<Lpo> lpos = new Vector<Lpo>();

		lpos.add(lpo);
		lpos.add(lpo2);

		return lpos;
	}

	public static Lpo getFirstExampleLpo() {
		Lpo lpo = new Lpo("waterWithCoffee");

		Vertex grind = lpo.addVertex("grind beans");
		Vertex off = lpo.addVertex("turn off");
		Vertex unlock = lpo.addVertex("unlock");
		Vertex empty = lpo.addVertex("empty");
		Vertex waterWithCoffee = lpo.addVertex("get water using coffee pot");
		Vertex fill = lpo.addVertex("fill");
		Vertex assemble = lpo.addVertex("assemble");

		lpo.connectVertices(grind, fill);
		lpo.connectVertices(off, unlock);
		lpo.connectVertices(unlock, empty);
		lpo.connectVertices(unlock, waterWithCoffee);
		lpo.connectVertices(empty, fill);
		lpo.connectVertices(fill, assemble);
		lpo.connectVertices(waterWithCoffee, assemble);

		lpo.finishConstruction();

		return lpo;
	}

	public static Lpo getSecondExampleLpo() {
		Lpo lpo = new Lpo("waterWithCoffee");

		Vertex grind = lpo.addVertex("grind beans");
		Vertex off = lpo.addVertex("turn off");
		Vertex unlock = lpo.addVertex("unlock");
		Vertex empty = lpo.addVertex("empty");
		Vertex waterWithGlass = lpo.addVertex("get water using glass pot");
		Vertex fill = lpo.addVertex("fill");
		Vertex assemble = lpo.addVertex("assemble");

		lpo.connectVertices(grind, fill);
		lpo.connectVertices(off, unlock);
		lpo.connectVertices(unlock, empty);
		lpo.connectVertices(empty, fill);
		lpo.connectVertices(fill, assemble);
		lpo.connectVertices(waterWithGlass, assemble);

		lpo.finishConstruction();

		return lpo;
	}

	public static Vector<Lpo> getPaperLpos() {
		Vector<Lpo> lpos = new Vector<Lpo>();

		lpos.add(getFirstPaperLpo());
		lpos.add(getSecondPaperLpo());
		lpos.add(getThirdPaperLpo());

		return lpos;
	}

	public static Lpo getFirstPaperLpo() {
		Lpo lpo = new Lpo("paper1");

		Vertex A = lpo.addVertex("A");
		Vertex B = lpo.addVertex("B");
		Vertex C = lpo.addVertex("C");
		Vertex D = lpo.addVertex("D");
		Vertex F = lpo.addVertex("F");

		lpo.connectVertices(A, B);
		lpo.connectVertices(A, D);
		lpo.connectVertices(B, C);
		lpo.connectVertices(C, F);
		lpo.connectVertices(D, F);

		lpo.finishConstruction();

		return lpo;
	}

	public static Lpo getSecondPaperLpo() {
		Lpo lpo = new Lpo("paper2");

		Vertex A = lpo.addVertex("A");
		Vertex E = lpo.addVertex("E");
		Vertex D = lpo.addVertex("D");
		Vertex F = lpo.addVertex("F");

		lpo.connectVertices(A, E);
		lpo.connectVertices(A, D);
		lpo.connectVertices(E, F);
		lpo.connectVertices(D, F);

		lpo.finishConstruction();

		return lpo;
	}

	public static Lpo getThirdPaperLpo() {
		Lpo lpo = new Lpo("paper3");

		Vertex A1 = lpo.addVertex("A");
		Vertex G1 = lpo.addVertex("G");
		Vertex A2 = lpo.addVertex("A");
		Vertex G2 = lpo.addVertex("G");

		lpo.connectVertices(A1, G1);
		lpo.connectVertices(G1, A2);
		lpo.connectVertices(A2, G2);

		lpo.finishConstruction();

		return lpo;
	}

}
