package de.fernunihagen.viptool.test.algorithm.folding.epcoflpo.datastructure.epc.buildingblocks;

import static org.junit.Assert.assertFalse;
import static org.junit.Assert.assertTrue;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;

import de.fernunihagen.viptool.algorithm.folding.epcoflpo.datastructure.epc.buildingblocks.BlockConnector;
import de.fernunihagen.viptool.algorithm.folding.epcoflpo.datastructure.epc.buildingblocks.BuildingBlock;
import de.fernunihagen.viptool.algorithm.folding.epcoflpo.datastructure.lpo.Activity;

public class TestBlockConnector {

	private BuildingBlock block;
	private Activity target;
	private Activity blockActivity;

	@Before
	public void setUp() throws Exception {
		target = Activity.getActivity("ConnectorTestActivity");
		blockActivity = Activity.getActivity("BlockActivity");
		block = new BuildingBlock(blockActivity);
	}

	@After
	public void tearDown() throws Exception {
	}

	@Test
	public void testCanFire() {
		BlockConnector connector = new BlockConnector(block, target);
		assertFalse(connector.canFire());
	}

	@Test
	public void testBlockConnector() {
		BlockConnector connector = new BlockConnector(block, target);

		assertTrue(connector.getTarget().equals(target));
	}

	@Test
	public void testEqualsObject() {
		BlockConnector connector1 = new BlockConnector(block, target);
		BlockConnector connector2 = new BlockConnector(block, target);

		assertTrue(connector1.equals(connector2));
	}
}
