package de.fernunihagen.viptool.test.algorithm.folding.epcoflpo.datastructure.lpo;

import static org.junit.Assert.assertTrue;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;

import de.fernunihagen.viptool.algorithm.folding.epcoflpo.datastructure.lpo.Activity;
import de.fernunihagen.viptool.algorithm.folding.epcoflpo.datastructure.lpo.Vertex;

public class TestActivity {

	@Before
	public void setUp() throws Exception {
	}

	@After
	public void tearDown() throws Exception {
	}

	@Test
	public void testGetActivity() {
		Activity testActivity = Activity.getActivity("Test");
		Activity activity = Activity.getActivity("Test");

		assertTrue(testActivity == activity);
		assertTrue(testActivity.getLabel().equals("Test"));
	}

	@Test
	public void testGetVertex() {
		Activity anActivity = Activity.getActivity("AnActivity");

		Vertex v = anActivity.getVertex();

		assertTrue(v.getActivity() == anActivity);
		assertTrue(v.getActivity().getLabel().equals("AnActivity"));
	}

	@Test
	public void testGetAllVertices() {
		Activity b = Activity.getActivity("B");

		Vertex v1 = b.getVertex();
		Vertex v2 = b.getVertex();

		assertTrue(b.getAllVertices().size() == 2);
		assertTrue(b.getAllVertices().contains(v1));
		assertTrue(b.getAllVertices().contains(v2));
	}

	@Test
	public void testAddVertex() {
		Activity x = Activity.getActivity("X");
		Activity y = Activity.getActivity("Y");

		Vertex xv1 = x.getVertex();
		Vertex xv2 = x.getVertex();

		assertTrue(x.getAllVertices().size() == 2);
		assertTrue(x.getAllVertices().contains(xv1));
		assertTrue(x.getAllVertices().contains(xv2));

		Vertex xv3 = new Vertex(x);
		x.addVertex(xv3);

		assertTrue(x.getAllVertices().size() == 3);
		assertTrue(x.getAllVertices().contains(xv3));

		x.addVertex(xv3);

		assertTrue(x.getAllVertices().size() == 3);
		assertTrue(x.getAllVertices().contains(xv3));

		Vertex yv = y.getVertex();
		x.addVertex(yv);

		assertTrue(x.getAllVertices().size() == 3);
		assertTrue(!x.getAllVertices().contains(yv));
	}

	@Test
	public void testGetLabel() {
		Activity c = Activity.getActivity("C");
		assertTrue(c.getLabel().equals("C"));
	}

	@Test
	public void testEqualsObject() {
		Activity c1 = Activity.getActivity("D");
		Activity c2 = Activity.getActivity("D");

		assertTrue(c1.equals(c2));
	}

}
